<?php

require_once('BTlib.php');

header('Content-type: text/xml; charset=UTF-8');
$xml = new XMLWriter();
$xml->openMemory();
$xml->setIndent(false);
$xml->startDocument('1.0', 'UTF-8');
$xml->startElement('Braintree');
do{

  if(isset($_POST['accessToken'])) {
    try{
      $gateway =  new Braintree_Gateway(['accessToken' => $_POST['accessToken']]);
    } catch(Braintree_Exception_Authentication $e) {
      $xml->writeElement('error', 'Authentication Error');
      break;
    } catch(Exception $e) {
      $xml->writeElement('error', 'Authentication Error');
      break;
    }
  } else {
    $xml->writeElement('error', 'Missing Parameters: accessToken');
    break;
  }

  try {
    $options = [];
    if(isset($_POST['merchantAccountId'])){
      $options['merchantAccountId'] = $_POST['merchantAccountId'];
    }
    $clientToken = $gateway->clientToken()->generate($options);
  } catch(Braintree_Exception_Authentication $e) {
    $xml->writeElement('error', 'Authentication Error');
    break;
  } catch(Exception $e) {
    $xml->writeElement('error', 'ClientToken Generation Failed');
    break;
  }
  $xml->writeElement('ClientToken', $clientToken);
}while(0);

$xml->endElement();
$xml->endDocument();
echo $xml->outputMemory(true);
